#include <stdio.h>
#include "mysystem.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
//#include <sys/prctl.h>

/* the ReSpawn Daemon... 
was originally going to be another process, but I forgot about fork() :D
*/

/* parse (from /etc/snailit/rspawns) only lines beginning with colon.

format is:

:foo:bar:

where /dev/foo is the terminal to open, and bar is the command to respawn
*/

/* Hey, only two processes per process!

and since I'm using fork, I can merge this into init! (/me goes to his home folder and rearranges stuff)

*/

#include "readfile.h"

//original location of the readfile code...

extern int errno;

int rsd() {
	char *buf = readfile("/etc/snailit/respawn");
	int len = strlen(buf);
	char *oldbuf = buf;
	int i = 0; //apparently, it would be a lot easier to use an index rather than incrementing the pointer :D
	char line[len];
	int lindex = 0;
	pid_t pid;
	while (i < len) { //main program loop - run through the file until done.
		if (buf[i] == ':') {
			//do stuff
			//printf("%s\n", buf);
			
			while (buf[i] != '\n' && buf[i] != '\0') {
				line[lindex] = buf[i];
				lindex++;
				i++;
			}
			line[lindex] = '\0';
		}
		else {
			//if it's not colon, jump to next line.
			while (buf[i] != '\n' && buf[i] != '\0') {
				i++;
			}
		}
		if (lindex) {	
			//work with line here
			
			//printf("%s\n", line);
			pid = fork();
			if (pid == -1)
				perror("fork");
			if (!pid) {
				//baby
				char terminal[128]; //good, arbitrary number...
				sprintf(terminal, "/dev/");
				for (i = 1; line[i] != ':'; i++)
					terminal[i+4] = line[i]; //okay, this took a second :D
				terminal[i+4] = '\0';
				i++;
				char command[128]; //again..
				int j = i;
				for (; line[i] != ':'; i++)
					command[i-j] = line[i]; //this one's not fixed
				command[i-j] = '\0';
				i++;
				//char commandname[len + 4]; //anyone know how to change process names?
				//sprintf(commandname, "rsd %s", command);
				//prctl(PR_SET_NAME, commandname, 0, 0, 0);
				while (1) //the actual respawn loop!
					mysystem(command, terminal, 1, 1);
			}
			lindex = 0;
		}
		i++; // don't start on newline
	}
	//AFTER everything else...
	buf = oldbuf;
	free(buf);
	return 0;
}
